do

	local oldModBlueprints = ModBlueprints
	local shrinkFactor = 2 -- math.sqrt(2.0) -- i should be able to define variables here.

	-- local sheep = , -- line 378

	function S(shrinkable)

		if not shrinkable then return nil end

		return shrinkable / shrinkFactor

	end
	
	function F(shrinkable) -- floored version, used for Intel as it's gay and stupid and only counts with {Z}.

		if not shrinkable then return nil end

		return math.floor(shrinkable / shrinkFactor)

	end
	
	function C(shrinkable) -- ceiling version, used for Intel as it's gay and stupid and only counts with {Z}.

		if not shrinkable then return nil end

		return math.ceil(shrinkable / shrinkFactor)

	end
		
	function ST(t)

		if not t then return end

		-- LOG("*BM: t = ", repr(t))

		for index, entry in t do

			entry = entry / shrinkFactor

		end

	end

	function ModBlueprints(all_bps)
		oldModBlueprints(all_bps)

		local shrink = 1 / shrinkFactor
		local p = nil -- dummy variable to cut down on the typing.

		all_bps.Unit["uxl0021"].Categories = {} -- just get rid of this damn thing.

		all_bps.Unit["xab2307"].Categories = { -- Salvation.
			'PRODUCTFA',
			'SELECTABLE',
			'BUILTBYTIER3ENGINEER',
			'BUILTBYTIER3COMMANDER',
			'AEON',
			'STRUCTURE',
			'STRATEGIC',
			'TECH3',
			'INDIRECTFIRE',
			'ARTILLERY',
			'DRAGBUILD',
			'SIZE20',
			'VISIBLETORECON',
			'RECLAIMABLE',
			'OVERLAYINDIRECTFIRE',
			'SORTSTRATEGIC',
   		}

   		all_bps.Unit["xab3301"].Categories = { -- Eye o' Rhianne
			'PRODUCTFA',
			'SELECTABLE',
			'BUILTBYTIER3ENGINEER',
			'BUILTBYTIER3COMMANDER',
			'AEON',
			'INTELLIGENCE',
			'STRUCTURE',
			'TECH3',
			'SIZE20',
			'OPTICS',
			'VISIBLETORECON',
			'RECLAIMABLE',
			'ABILITYBUTTON',
			'SORTINTEL',
		}

		for id, bp in all_bps.Unit do

--			LOG("*BM: ", bp.BlueprintId)

			local cats = {} -- cats, meow.
			for ik, cat in bp.Categories do
				cats[cat] = true
			end

			-- Adjacency.

			-- AI.
			bp.GuardRadius = S(bp.GuardRadius)
			bp.GuardReturnRadius = S(bp.GuardReturnRadius)
			bp.GuardScanRadius = S(bp.GuardScanRadius)

			-- Air.
			p = bp.Air
			if p then
				p.BombDropThreshold = S(p.BombDropThreshold)
				p.BreakOffDistance = S(p.BreakOffDistance)
				p.BreakOffTrigger = S(p.BreakOffTrigger)
				p.CombatTurnSpeed = S(p.CombatTurnSpeed)
				p.EngageDistance = S(p.EngageDistance)
				p.LiftFactor = S(p.LiftFactor)
				p.MaxAirSpeed = S(p.MaxAirspeed)
				p.MaxEngineThrust = S(p.MaxEngineThrust)
				p.MaxEngineTorque = S(p.MaxEngineTorque)
				p.MinAirSpeed = S(p.MinAirspeed)
				p.StartTurnDistance = S(p.StartTurnDistance)
				p.TransportHoverHeight = S(p.TransportHoverHeight)
				p.TurnSpeed = S(p.TurnSpeed)
			end

			-- Audio.

			-- AverageDensity.

			-- BlueprintId.

			-- Buffs.

			-- BuildIconSortPriority.

			-- Categories.

			-- CollisionOffsetX, CollisionOffsetY, CollisionOffsetZ.
			bp.CollisionOffsetX = S(bp.CollisionOffsetX)
			bp.CollisionOffsetY = S(bp.CollisionOffsetY)
			bp.CollisionOffsetZ = S(bp.CollisionOffsetZ)

			-- CollisionShape.

			-- Defense.
			p = bp.Defense.Shield
			if p then
				p.ShieldSize = S(p.ShieldSize)
				p.ShieldVerticalOffset = S(p.ShieldVerticalOffset)
			end

			-- Description.

			-- Display.
			if bp.Display.BlinkingLights then 
				for ik, light in bp.Display.BlinkingLights do
--					light.BLBone = S(light.BLBone) -- i have no idea what in hells name this is for.
					light.BLOffsetX = S(light.BLOffsetX)
					light.BLOffsetY = S(light.BLOffsetY)
					light.BLOffsetZ = S(light.BLOffsetZ)
					light.BLScale = S(light.BLScale)
				end
			end

			-- bp.Display.IdleEffects.Land
			if bp.Display.IdleEffects.Land.Effects then
				for ik, effect in bp.Display.IdleEffects.Land.Effects do
					ST(effect.Offset)
					effect.Scale = S(effect.Scale)
				end
			end

			if bp.Display.IdleEffects.Water.Effects then
				for ik, effect in bp.Display.IdleEffects.Water.Effects do
					ST(effect.Offset)
					effect.Scale = S(effect.Scale)
				end
			end

			-- bp.Display.MovementEffects.Air.Contrails
			p = bp.Display.MovementEffects.Air.Contrails
			if p then
				p.XOffset = S(p.XOffset)
				p.YOffset = S(p.YOffset)
				p.ZOffset = S(p.ZOffset)
			end

			-- some random effect for land units.
			if bp.Display.MovementEffects.Land.Effects then
				for ik, effect in bp.Display.MovementEffects.Land.Effects do
					ST(effect.Offset)
					effect.Scale = S(effect.Scale)
				end
			end

			-- bp.Display.MovementEffects.Water
			if bp.Display.MovementEffects.Water.Effects then
				for ik, effect in bp.Display.MovementEffects.Water.Effects do
					ST(effect.Offset)
					effect.Scale = S(effect.Scale)
				end
			end

			-- fooooot prints and stuff.
			if bp.Display.MovementEffects.Land.Footfall then
				for ik, bone in bp.Display.MovementEffects.Land.Footfall.Bones do
					if bone.Tread then
						bone.Tread.TreadMarksSizeX = S(bone.Tread.TreadMarksSizeX)
						bone.Tread.TreadMarksSizeZ = S(bone.Tread.TreadMarksSizeZ)
						ST(bone.Tread.TreadOffset)
					end
				end
			end

			if bp.Display.MovementEffects.Seabed.Footfall then
				for ik, bone in bp.Display.MovementEffects.Seabed.Footfall.Bones do
					if bone.Tread then
						bone.Tread.TreadMarksSizeX = S(bone.Tread.TreadMarksSizeX)
						bone.Tread.TreadMarksSizeZ = S(bone.Tread.TreadMarksSizeZ)
						ST(bone.Tread.TreadOffset)
					end
				end
			end

			-- bp.Display.MovementEffects.Land.Treads
			if bp.Display.MovementEffects.Land.Treads.TreadMarks then
				for ik, mark in bp.Display.MovementEffects.Land.Treads.TreadMarks do
					mark.TreadMarksInterval = S(mark.TreadMarksInterval)
					mark.TreadMarksSizeX = S(mark.TreadMarksSizeX)
					mark.TreadMarksSizeZ = S(mark.TreadMarksSizeZ)
					ST(mark.TreadOffset)
				end
			end

			-- bp.Display.Tarmacs
            if bp.Display.Tarmacs then
				for ik, Tarmac in bp.Display.Tarmacs do
					Tarmac.Length = S(Tarmac.Length)
					Tarmac.Width = S(Tarmac.Width)
				end
			end

			if not (cats.MASSEXTRACTION or cats.HYDROCARBON or cats.WALL) then
				bp.Display.UniformScale = S(bp.Display.UniformScale)
			end

			-- Economy.

			-- Enhancements.

			-- Footprint.
			p = bp.Footprint
			if p then
				p.SizeX = F(p.SizeX)
				p.SizeZ = F(p.SizeZ)
			end

			-- General.

			-- Intel.
			p = bp.Intel
			if p then
				p.CloakFieldRadius = F(p.CloakFieldRadius)
				if p.JamRadius then
					p.JamRadius.Max = S(p.JamRadius.Max)
					p.JamRadius.Min = S(p.JamRadius.Min)
				end
				p.OmniRadius = F(p.OmniRadius)
				p.RadarRadius = F(p.RadarRadius)
				p.RadarStealthFieldRadius = F(p.RadarStealthFieldRadius)
				p.SonarRadius = F(p.SonarRadius)
				p.SonarStealthFieldRadius = F(p.SonarStealthFieldRadius)
				if p.SpoofRadius then
					p.SpoofRadius.Max = S(p.SpoofRadius.Max)
					p.SpoofRadius.Min = S(p.SpoofRadius.Min)
				end
				p.VisionRadius = S(p.VisionRadius)
				p.WaterVisionRadius = S(p.WaterVisionRadius)
			end

			-- LifeBarHeight, LifeBarOffset, LifeBarSize.
			bp.LifeBarHeight = S(bp.LifeBarHeight)
			bp.LifeBarOffset = S(bp.LifeBarOffset)
			bp.LifeBarSize = S(bp.LifeBarSize)

			-- Merge. lol, like i need this.

			-- Physics.
			p = bp.Physics
			if p then 
				p.AttackElevation = S(p.AttackElevation)
				p.BackupDistance = S(p.BackupDistance)
				p.CatchUpAcc = S(p.CatchUpAcc)
				p.Elevation = S(p.Elevation)
				p.MaxAcceleration = S(p.MaxAcceleration)
				p.MaxBrake = S(p.MaxBrake)
				p.MaxSpeed = S(p.MaxSpeed)
				p.MaxReverse = S(p.MaxReverse)

				-- do some funny things for the raised platforms.
				ST(p.RaisedPlatforms)

				if p.RollOffPoints then 
					for ik, RollOffPoint in p.RollOffPoints do
						ST(RollOffPoint)
					end
				end
				-- logic to stop ghey Mexes, Hydros, Walls, T4s, and Stagings.
				if not (cats.MASSEXTRACTION or cats.HYDROCARBON or cats.WALL or cats.AIRSTAGINGPLATFORM) then
					-- put MeshExtents in here, so Walls and such have proper build effects.
					p.MeshExtentsX = S(p.MeshExtentsX)
					p.MeshExtentsY = S(p.MeshExtentsY)
					p.MeshExtentsZ = S(p.MeshExtentsZ)
					if cats.SIZE4 then
						p.SkirtOffsetX = -F(p.SkirtOffsetX)
						p.SkirtOffsetZ = -F(p.SkirtOffsetZ)
						p.SkirtSizeX = F(p.SkirtSizeX)
						p.SkirtSizeZ = F(p.SkirtSizeZ)
					elseif cats.SIZE8 then
						p.SkirtSizeX = C(p.SkirtSizeX)
						p.SkirtSizeZ = C(p.SkirtSizeZ)
					elseif cats.SIZE12 or cats.SIZE16 then
						p.SkirtOffsetX = F(p.SkirtOffsetX)
						p.SkirtOffsetZ = F(p.SkirtOffsetZ)
						p.SkirtSizeX = F(p.SkirtSizeX)
						p.SkirtSizeZ = F(p.SkirtSizeZ)
					elseif cats.SIZE20 then
						p.SkirtOffsetX = F(p.SkirtOffsetX)
						p.SkirtOffsetZ = F(p.SkirtOffsetZ)
						p.SkirtSizeX = C(p.SkirtSizeX)
						p.SkirtSizeZ = C(p.SkirtSizeZ)
					end
				end
				if cats.EXPERIMENTAL and bp.SizeX > 1 and bp.SizeZ > 1 and not cats.STRUCTURE then
					p.SkirtOffsetX = F(p.SkirtOffsetX)
					p.SkirtOffsetZ = F(p.SkirtOffsetZ)
					p.SkirtSizeX = F(p.SkirtSizeX)
					p.SkirtSizeZ = F(p.SkirtSizeZ)	
				end
				if cats.AIRSTAGINGPLATFORM and cats.STRUCTURE then
					p.SkirtOffsetX = -0.5 -- S(p.SkirtOffsetX)
					p.SkirtOffsetZ = -0.5 -- S(p.SkirtOffsetZ)
					p.SkirtSizeX = F(p.SkirtSizeX)
					p.SkirtSizeZ = F(p.SkirtSizeZ)
				end
				p.TurnRadius = S(p.TurnRadius)
			end
					
			-- SelectionCentreOffsetX, SelectionCentreOffsetY, SelectionCentreOffsetZ.
			if not (cats.MASSEXTRACTION or cats.HYDROCARBON or cats.WALL) then
				bp.SelectionCentreOffsetX = S(bp.SelectionCentreOffsetX)
				bp.SelectionCentreOffsetY = S(bp.SelectionCentreOffsetY)
				bp.SelectionCentreOffsetZ = S(bp.SelectionCentreOffsetZ)

				-- SelectionSizeX, SelectionSizeY, SelectionSizeZ.
				bp.SelectionSizeX = S(bp.SelectionSizeX)
				bp.SelectionSizeY = S(bp.SelectionSizeY)
				bp.SelectionSizeZ = S(bp.SelectionSizeZ)

				-- SelectionThickness.
				bp.SelectionThickness = S(bp.SelectionThickness)

				-- SelectionYOffset.
				bp.SelectionYOffset = S(bp.SelectionYOffset)
			end


			-- SizeX, SizeY, SizeZ.
			bp.SizeX = S(bp.SizeX)
			bp.SizeY = S(bp.SizeY)
			bp.SizeZ = S(bp.SizeZ)

			-- SizeSphere.
			bp.SphereSize = S(bp.SphereSize)

			-- StrategicIconName.

			-- StrategicIconSortPriority.

			-- Transport.

			-- UseOOBTestZoom.

			-- Veteren.

--			LOG("*BM: ", bp.BlueprintId)

			-- Weapon.
			if bp.Weapon then
				for ik, weap in bp.Weapon do

--					LOG("*BM: looping weapon ", ik)

					if weap.Buffs then
						for ij, Buff in weap.Buffs do
							Buff.Radius = S(Buff.Radius)
						end
					end
					weap.DamageRadius = C(weap.DamageRadius)
					weap.FiringRandomness = S(weap.FiringRandomness)
					weap.FiringTolerance = S(weap.FiringTolerance)
					weap.MaxRadius = C(weap.MaxRadius)
					weap.MinRadius = F(weap.MinRadius)
--					weap.MuzzleVelocity = S(weap.MuzzleVelocity)
--					weap.MuzzleVelocityReduceDistance = S(weap.MuzzleVelocityReduceDistance)
					weap.RackRecoilDistance = S(weap.RackRecoilDistance)
					weap.TrackingRadius = S(weap.TrackingRadius)
				end
			end

			-- Wreckage.

		end # all_bps.Unit loop

		for id, proj in all_bps.Projectile do

			p = proj.Display
			if p then
				p.UniformScale = S(p.UniformScale)
			end

			p = proj.Physics
			if p then
				p.Acceleration = S(p.Acceleration)
				p.InitialSpeed = S(p.InitialSpeed)
				p.MaxSpeed = S(p.MaxSpeed)
			end

		end # all_bps.Unit loop

	end # ModBlueprints()
	
end